# Submission Guideline

- Replace `XX` with your team number with leading zero (e.g. `02`).
- One submission *per team*.
- Familiarise yourself with the `git archive` command.

## Feedback Request

1. Run the following command, assuming you want to submit the currently checked out version:

        $ git archive --prefix=feedback_request/ --format=zip HEAD > feedback_request.zip

2. Verify that the resulting archive contains everything you want to submit and nothing more.
3. Ensure that the resulting archive does not contain any personal information like names or student IDs.
4. Submit the archive via mail using the following line as subject (or link below).

        703602 - Feedback Request

    📧 [send email](mailto:alexander.hirsch@uibk.ac.at?subject=703602%20-%20Feedback%20Request)

## Build Test Submission

1. Run the following command, assuming you want to submit the currently checked out version:

        $ git archive --prefix=team_XX_build_test/ --format=zip HEAD > team_XX_build_test.zip

2. Verify that the resulting archive contains everything you want to submit and nothing more.
3. Submit the archive via mail using the following line as subject (or link below).

        703602 - Team XX Build Test Submission

    📧 [send email](mailto:alexander.hirsch@uibk.ac.at?subject=703602%20-%20Team%20XX%20Build%20Test%20Submission)

## Final Submission

1. Run the following command, assuming you want to submit the currently checked out version:

        $ git archive --prefix=team_XX_final/ --format=zip HEAD > team_XX_final.zip

2. Verify that the resulting archive contains everything you want to submit and nothing more.
3. Ensure everything works.
    - Everything builds
    - No (unjustified) warnings
    - All unit tests succeed
    - All integration tests succeed
    - No memory is leaked
    - Known issues is present and up-to-date
4. Submit the archive via mail using the following line as subject (or link below).

        703602 - Team XX Final Submission

    📧 [send email](mailto:alexander.hirsch@uibk.ac.at?subject=703602%20-%20Team%20XX%20Final%20Submission)
